[LeetCode] House Robber II

1、题目

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.

Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

2、分析

这个其实还是原来的方法,只不过街道变成了圆形,第一个和最后一个是相邻的。一开始我是不知道怎么处理这种情况的,然后找了找答案发现,分别计算去头去尾的最大可能结果,两个取最大值就是最终结果,仔细思考了一下发现十分有道理。

3、代码

class Solution {
public:
    int rob(vector<int>& nums) {
        int m1 = 0,m2=0;
        int n = nums.size();
        if(n==0) return 0;
        if(n==1) return nums[0];
        if(n==2) return max(nums[0],nums[1]);
        return max(rob(nums,0,n-1),rob(nums,1,n));
    }
        int rob(vector<int>& nums,int left,int right)
        {
            if(right - left == 2) return max(nums[left],nums[right-1]);
            int nn = right - left;
            int dp[nn];
            dp[0] = nums[left];
            dp[1] = max(nums[left],nums[left+1]);
            for(int i=2;i<nn;i++)
                dp[i] = max(dp[i-2]+nums[i+left],dp[i-1]);
            return dp[nn-1];
        }
        
    
};

猜你喜欢

转载自blog.csdn.net/qq_36303832/article/details/82926197
今日推荐